## audacity 2.4.1

=== CMakeLists.txt ===
# If you want built-in precompiled header support
# then make sure you have cmake 3.16 or higher.
#
# Minimum required is 3.15 due to use of multiple values in
# generator expressions.
cmake_minimum_required( VERSION 3.15 )

# Don't allow in-source builds...no real reason, just
# keeping those source trees nice and tidy.  :-)
# (This can be removed if it becomes an issue.)
if( "${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}" )
   message( FATAL_ERROR
      "In-source builds not allowed.\n"
      "Create a new directory and run cmake from there, i.e.:\n"
      "  mkdir build\n"
      "  cd build\n"
      "  cmake ..\n"
      "You will need to delete CMakeCache.txt and CMakeFiles from this directory to clean up."
   )
endif()

# Just a couple of convenience variables
set( topdir "${CMAKE_SOURCE_DIR}" )
set( libsrc "${topdir}/lib-src" )

# Ignore COMPILE_DEFINITIONS_<Config> properties
cmake_policy( SET CMP0043 NEW )

# Link libraries by full path even in implicit directories.
cmake_policy( SET CMP0060 NEW )

# ``INTERPROCEDURAL_OPTIMIZATION`` is enforced when enabled.
cmake_policy( SET CMP0069 NEW )

# ``FindOpenGL`` prefers GLVND by default when available.
cmake_policy( SET CMP0072 NEW )

# Include file check macros honor ``CMAKE_REQUIRED_LIBRARIES``.
cmake_policy( SET CMP0075 NEW )

# Definitions that must happen before the project() command
if( APPLE )

   # Generate schema files
   set( CMAKE_XCODE_GENERATE_SCHEME ON )

   # Define the OSX compatibility parameters
   set( CMAKE_OSX_ARCHITECTURES x86_64 CACHE INTERNAL "" )
   set( CMAKE_OSX_DEPLOYMENT_TARGET 10.7 CACHE INTERNAL "" )
   set( CMAKE_OSX_SYSROOT macosx CACHE INTERNAL "" )
   set( CMAKE_XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY "" CACHE INTERNAL "" )

   # This prevents a link error when building with the 10.9 or older SDKs
   set( CMAKE_XCODE_ATTRIBUTE_CLANG_LINK_OBJC_RUNTIME OFF )

   # Shouldn't cmake do this???
   string( APPEND CMAKE_CXX_FLAGS " -stdlib=libc++" )
endif()

# Add our module path
set( CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake-proxies/cmake-modules)

# This "is a good thing" but greatly increases link time on Linux
#set( CMAKE_INTERPROCEDURAL_OPTIMIZATION ON )
#set( CMAKE_INTERPROCEDURAL_OPTIMIZATION_RELEASE ON )
#set( CMAKE_INTERPROCEDURAL_OPTIMIZATION_DEBUG OFF )

# Set the required C++ standard
set( CMAKE_CXX_STANDARD 14 )
set( CMAKE_CXX_STANDARD_REQUIRED ON )

# Use ccache if available
find_program( CCACHE_PROGRAM ccache )
mark_as_advanced( FORCE CCACHE_PROGRAM )

if( CCACHE_PROGRAM )
   set_property( GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_PROGRAM}" )
endif()

# Our very own project
project( Audacity )

# Load our functions/macros
include( AudacityFunctions )

# Pull all the modules we'll need
include( CheckCXXCompilerFlag )
include( CheckIncludeFile )
include( CheckIncludeFiles )
include( CheckLibraryExists )
include( CheckSymbolExists )
include( CheckTypeSize )
include( CMakeDependentOption )
include( CMakeDetermineASM_NASMCompiler )
include( CMakePushCheckState )
include( GNUInstallDirs )
include( TestBigEndian )

message( STATUS "Build Info:" )
message( STATUS "  Host System: ${CMAKE_HOST_SYSTEM}" )
message( STATUS "  Host System Name: ${CMAKE_HOST_SYSTEM_NAME}" )
message( STATUS "  Host System Processor: ${CMAKE_HOST_SYSTEM_PROCESSOR}" )
message( STATUS "  Host System Version: ${CMAKE_HOST_SYSTEM_VERSION}" )
message( STATUS )
message( STATUS "  Compiler: ${CMAKE_CXX_COMPILER}" )
message( STATUS "  Compiler Version: ${CMAKE_CXX_COMPILER_VERSION}" )
message( STATUS "  Compiler Standard: ${CMAKE_CXX_STANDARD}" )
message( STATUS "  Compiler Standard Required: ${CMAKE_CXX_STANDARD_REQUIRED}" )
message( STATUS "  Compiler Extensions: ${CMAKE_CXX_EXTENSIONS}" )
message( STATUS )

if( CMAKE_GENERATOR MATCHES "Visual Studio" )
   message( STATUS "  MSVC Version: ${MSVC_VERSION}" )
   message( STATUS "  MSVC Toolset: ${MSVC_TOOLSET_VERSION}" )
   message( STATUS ) 
elseif( CMAKE_SYSTEM_NAME MATCHES "Darwin" )
   if( CMAKE_GENERATOR MATCHES "Xcode" )
      message( STATUS "  Xcode Version: ${XCODE_VERSION}" )
   endif()
   message( STATUS "  MacOS SDK: ${CMAKE_OSX_SYSROOT}" )
   message( STATUS )
endif()

# Try to get the current commit information
set( GIT_COMMIT_SHORT "unknown" )
set( GIT_COMMIT_LONG "unknown" )
set( GIT_COMMIT_TIME "unknown" )
find_package( Git QUIET )
if( GIT_FOUND )
   execute_process(
      COMMAND
         ${GIT_EXECUTABLE} show -s "--format=%h;%H;%cd"
      WORKING_DIRECTORY
         ${topdir}
      OUTPUT_VARIABLE
         git_output
      OUTPUT_STRIP_TRAILING_WHITESPACE
      ERROR_QUIET
   )

   if( git_output )
      list( GET git_output 0 GIT_COMMIT_SHORT )
      list( GET git_output 1 GIT_COMMIT_LONG )
      list( GET git_output 2 GIT_COMMIT_TIME )
   endif()
endif()
message( STATUS "  Current Commit: ${GIT_COMMIT_SHORT}" )
message( STATUS )

# Define option() prefix
set( _OPT "audacity_" )

# Organize subdirectories/targets into folders for the IDEs
set_property( GLOBAL PROPERTY USE_FOLDERS ON )

if( CMAKE_GENERATOR MATCHES "Visual Studio" )
   # Make sure Audacity is the startup project
   set_directory_properties(
      PROPERTIES
         VS_STARTUP_PROJECT "${CMAKE_PROJECT_NAME}"
   )

   # Build using multiple processors
   foreach( config ${CMAKE_CONFIGURATION_TYPES} )
      string( TOUPPER "${config}" config )
      string( APPEND CMAKE_C_FLAGS_${config} " /MP" )
      string( APPEND CMAKE_CXX_FLAGS_${config} " /MP" )
   endforeach()

   # Define system library information, but we'll do the install
   set( CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS_SKIP YES )
   set( CMAKE_INSTALL_UCRT_LIBRARIES NO )
   set( CMAKE_INSTALL_MFC_LIBRARIES NO )
   set( CMAKE_INSTALL_OPENMP_LIBRARIES NO )
   include( InstallRequiredSystemLibraries )
endif()

# Where the final product is stored
set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}/audacity )
set( CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}/audacity )
set( CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin )

# Set up RPATH handling
set( CMAKE_SKIP_BUILD_RPATH FALSE )
set( CMAKE_BUILD_WITH_INSTALL_RPATH FALSE )
set( CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_FULL_LIBDIR}/audacity" )
set( CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE )
set( CMAKE_MACOSX_RPATH FALSE )

# the RPATH to be used when installing, but only if it's not a system directory
#list( FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_FULL_LIBDIR}" isSysDir )
#if( "${isSysDir}" STREQUAL "-1" )
#   set( CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib" )
#endif()

# Add the math library (if found) to the list of required libraries
check_library_exists( m pow "" HAVE_LIBM )
if( HAVE_LIBM )
   list( APPEND CMAKE_REQUIRED_LIBRARIES -lm )
endif()

check_library_exists( atomic __atomic_fetch_add_4 "" HAVE_LIBATOMIC )
if( HAVE_LIBATOMIC )
  list( APPEND CMAKE_REQUIRED_LIBRARIES -latomic )
endif()

# Add the dynamic linker library (if needed) to the list of required libraries
list( APPEND CMAKE_REQUIRED_LIBRARIES ${CMAKE_DL_LIBS} )

# Make sure they're used during the link steps
set( CMAKE_LINK_INTERFACE_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} )

# Various common checks whose results are used by the different targets
test_big_endian( WORDS_BIGENDIAN )

# Check for compiler flags
if( CMAKE_CXX_COMPILER_ID MATCHES "AppleClang|Clang|GNU" )
   check_cxx_compiler_flag( "-mmmx" HAVE_MMX )
   if( HAVE_MMX )
      set( MMX_FLAG "-mmmx" CACHE INTERNAL "" )
   endif()

   check_cxx_compiler_flag( "-msse" HAVE_SSE )
   if( HAVE_SSE )
      set( SSE_FLAG "-msse" CACHE INTERNAL "" )
   endif()

   check_cxx_compiler_flag( "-msse2" HAVE_SSE2 )
   if( HAVE_SSE2 )
      set( SSE_FLAG "-msse2" CACHE INTERNAL "" )
   endif()
elseif( CMAKE_CXX_COMPILER_ID MATCHES "MSVC" )
   set( HAVE_MMX ON )
   set( MMX_FLAG "" )
   set( HAVE_SSE ON )
   set( SSE_FLAG "/arch:SSE" )
   set( HAVE_SSE2 ON )
   set( SSE2_FLAG "/arch:SSE2" )
endif()

check_include_files( "float.h;stdarg.h;stdlib.h;string.h" STDC_HEADERS )

check_include_file( "assert.h" HAVE_ASSERT_H )
check_include_file( "errno.h" HAVE_ERRNO_H )
check_include_file( "fcntl.h" HAVE_FCNTL_H )
check_include_file( "fenv.h" HAVE_FENV_H )
check_include_file( "inttypes.h" HAVE_INTTYPES_H )
check_include_file( "limits.h" HAVE_LIMITS_H )
if( CMAKE_SYSTEM_NAME MATCHES "FreeBSD" )
  check_include_file( "stdlib.h" HAVE_MALLOC_H )
  check_include_file( "sys/endian.h" HAVE_ENDIAN_H )
else()
  check_include_file( "malloc.h" HAVE_MALLOC_H )
  check_include_file( "byteswap.h" HAVE_BYTESWAP_H )
endif()
check_include_file( "memory.h" HAVE_MEMORY_H )
check_include_file( "stdbool.h" HAVE_STDBOOL_H )
check_include_file( "stdint.h" HAVE_STDINT_H )
check_include_file( "stdlib.h" HAVE_STDLIB_H )
check_include_file( "string.h" HAVE_STRING_H )
check_include_file( "strings.h" HAVE_STRINGS_H )
check_include_file( "unistd.h" HAVE_UNISTD_H )
check_include_file( "xmmintrin.h" HAVE_XMMINTRIN_H )
check_include_file( "sys/param.h" HAVE_SYS_PARAM_H )
check_include_file( "sys/stat.h" HAVE_SYS_STAT_H )
check_include_file( "sys/types.h" HAVE_SYS_TYPES_H )
check_include_file( "sys/wait.h" HAVE_SYS_WAIT_H )

check_symbol_exists( bcopy "strings.h" HAVE_BCOPY )
check_symbol_exists( fileno "stdio.h" HAVE_FILENO )
check_symbol_exists( flock "sys/file.h" HAVE_FLOCK )
check_symbol_exists( fork "unistd.h" HAVE_FORK )
check_symbol_exists( fsync "unistd.h" HAVE_FSYNC )
check_symbol_exists( ftruncate "unistd.h" HAVE_FTRUNCATE )
check_symbol_exists( getpagesize "unistd.h" HAVE_GETPAGESIZE )
check_symbol_exists( gettimeofday "sys/time.h" HAVE_GETTIMEOFDAY )
check_symbol_exists( gmtime "time.h" HAVE_GMTIME )
check_symbol_exists( gmtime_r "time.h" HAVE_GMTIME_R )
check_symbol_exists( lrint "math.h" HAVE_LRINT )
check_symbol_exists( lrintf "math.h" HAVE_LRINTF )
check_symbol_exists( lround "math.h" HAVE_LROUND )
check_symbol_exists( lstat "sys/stat.h" HAVE_LSTAT )
check_symbol_exists( memcpy "string.h" HAVE_MEMCPY )
check_symbol_exists( memmove "string.h" HAVE_MEMMOVE )
check_symbol_exists( mlock "sys/mman.h" HAVE_MLOCK )
check_symbol_exists( pipe "unistd.h" HAVE_PIPE )
check_symbol_exists( posix_fadvise "fcntl.h" HAVE_POSIX_FADVISE )
check_symbol_exists( posix_memalign "stdlib.h" HAVE_POSIX_MEMALIGN )
check_symbol_exists( strchr "string.h" HAVE_STRCHR )
check_symbol_exists( waitpid "sys/wait.h" HAVE_WAITPID )

check_type_size( "int8_t" SIZEOF_INT8 LANGUAGE C )
check_type_size( "int16_t" SIZEOF_INT16 LANGUAGE C )
check_type_size( "uint16_t" SIZEOF_UINT16 LANGUAGE C )
check_type_size( "u_int16_t" SIZEOF_U_INT16 LANGUAGE C )
check_type_size( "int32_t" SIZEOF_INT32 LANGUAGE C )
check_type_size( "uint32_t" SIZEOF_UINT32 LANGUAGE C )
check_type_size( "u_int32_t" SIZEOF_U_INT32 LANGUAGE C )
check_type_size( "int64_t" SIZEOF_INT64 LANGUAGE C )
check_type_size( "short" SIZEOF_SHORT LANGUAGE C )
check_type_size( "unsigned short" SIZEOF_UNSIGNED_SHORT LANGUAGE C )
check_type_size( "int" SIZEOF_INT LANGUAGE C )
check_type_size( "unsigned int" SIZEOF_UNSIGNED_INT LANGUAGE C )
check_type_size( "long" SIZEOF_LONG LANGUAGE C )
check_type_size( "unsigned long" SIZEOF_UNSIGNED_LONG LANGUAGE C )
check_type_size( "long long" SIZEOF_LONG_LONG LANGUAGE C )
check_type_size( "unsigned long long" SIZEOF_UNSIGNED_LONG_LONG LANGUAGE C )
check_type_size( "float" SIZEOF_FLOAT LANGUAGE C )
check_type_size( "double" SIZEOF_DOUBLE LANGUAGE C )
check_type_size( "long double" SIZEOF_LONG_DOUBLE LANGUAGE C )
check_type_size( "loff_t" SIZEOF_LOFF LANGUAGE C )
check_type_size( "off_t" SIZEOF_OFF LANGUAGE C )
check_type_size( "off64_t" SIZEOF_OFF64 LANGUAGE C )
check_type_size( "size_t" SIZEOF_SIZE LANGUAGE C )
check_type_size( "wchar_t" SIZEOF_WCHAR LANGUAGE C )
check_type_size( "void*" SIZEOF_POINTER LANGUAGE C )

# Determine 32-bit or 64-bit target
if( CMAKE_C_COMPILER_ID MATCHES "MSVC" AND CMAKE_VS_PLATFORM_NAME MATCHES "Win64|x64" )
   set( IS_64BIT ON )
elseif( NOT CMAKE_SIZEOF_VOID_P STREQUAL "4" )
   set( IS_64BIT ON )
endif()

if( IS_64BIT )

=== cmake-proxies/CMakeLists.txt ===
# Allow user to globally set the library preference
cmd_option( ${_OPT}lib_preference
            "Library preference [system (if available), local]"
            "system"
            STRINGS "system" "local"
)

#
# Add individual library targets
#
# Parms:
#     dir      directory name within the cmake-proxies directory.
#              (Doesn't HAVE to match the same directory in lib-src,
#              but it usually does.)
#
#     name     suffix for the cmake user options
#
#     symbol   suffix for the "USE_<symbol>" variable that the Audacity
#              target uses to include/exclude functionality.
#
#     requried Determines if the library is required or not.  If it is,
#              the user is not given the option of enabling/disabling it.
#
#     check    Determines if local/system checks should be performed here
#              or in the subdirectory config.
#
#     packages A list of packages required for this target in pkg-config
#              format.
function( addlib dir name symbol required check )
   # Extract the list of packages from the function args
   list( SUBLIST ARGV 5 -1 packages )

   # Define target's name and it's source directory
   set( TARGET ${dir} )
   set( TARGET_ROOT ${libsrc}/${dir} )

   # Define the option name
   set( use ${_OPT}use_${name} ) 

   # If we're not checking for system or local here, then let the
   # target config handle the rest.
   if( NOT check )
      add_subdirectory( ${dir} EXCLUDE_FROM_ALL )
      return()
   endif()

   # If the target isn't required, allow the user to select which one
   # to use or disable it entirely
   set( desc "local" )
   if( packages )
      set( sysopt "system" )
      string( PREPEND desc "system (if available), " )
      set( default "${${_OPT}lib_preference}" )
   else()
      set( default "local" )
   endif()

   if( NOT required )
      set( reqopt "off" )
      string( APPEND desc ", off" )
   endif()

   cmd_option( ${use}
               "Use ${name} library [${desc}]"
               "${default}"
               STRINGS ${sysopt} "local" ${reqopt}
   )

   # Bail if the target will not be used
   if( ${use} STREQUAL "off" )
      message( STATUS "========== ${name} disabled ==========" )

      set( USE_${symbol} OFF CACHE INTERNAL "" FORCE )

      return()
   endif()

   # Let the Audacity target know that this library will be used
   set( USE_${symbol} ON CACHE INTERNAL "" FORCE )

   message( STATUS "========== Configuring ${name} ==========" )

   # Check for the system package(s) if the user prefers it
   if( ${use} STREQUAL "system" )
      # Look them up
      pkg_check_modules( PKG_${TARGET} ${packages} )
      if( PKG_${TARGET}_FOUND )
         message( STATUS "Using '${name}' system library" )

         # Create the target interface library
         add_library( ${TARGET} INTERFACE IMPORTED GLOBAL )

         # Retrieve the package information
         get_package_interface( PKG_${TARGET} )

         # And add it to our target
         target_include_directories( ${TARGET} INTERFACE ${INCLUDES} )
         target_link_libraries( ${TARGET} INTERFACE ${LIBRARIES} )
      else()
         set( ${use} "local" )
         set_property( CACHE ${use} PROPERTY VALUE "local" )
      endif()
   endif()

   # User wants the local package or the system one wasn't found
   if( ${use} STREQUAL "local" )
      message( STATUS "Using '${name}' local library" )

      # Pull in the target config
      add_subdirectory( ${dir} EXCLUDE_FROM_ALL )

      # Get the list of targets defined by that config
      get_property( targets DIRECTORY "${dir}" PROPERTY BUILDSYSTEM_TARGETS )

      # Set the folder (for the IDEs) for each one
      foreach( target ${targets} )
         # Skip interface libraries since they don't have any source to
         # present in the IDEs   
         get_target_property( type "${target}" TYPE )
         if( NOT "${type}" STREQUAL "INTERFACE_LIBRARY" )
            set_target_properties( ${target} PROPERTIES FOLDER "lib-src" )
         endif()
      endforeach()
   endif()

   # Define a library alias for each of the packages
   foreach( package ${packages} )
      # Convert the package spec to a list
      string( REPLACE " " ";" package "${package}" )

      # And extract just the package name
      list( GET package 0 package )

      # But only if the package name doesn't conflict with the
      # target name.
      if( NOT TARGET ${package} )
         # Create the alias
         add_library( "${package}" ALIAS ${TARGET} )
      endif()
   endforeach()
endfunction()

# Required libraries
#
#       directory          option      symbol      req   chk   version
addlib( wxWidgets          wxwidgets   WX          YES   NO    "" ) # must be first
addlib( FileDialog         FileDialog  FILEDIALOG  YES   YES   "" )
addlib( expat              expat       EXPAT       YES   YES   "expat >= 2.1.0" )
addlib( lame               lame        LAME        YES   YES   "lame >= 3.100" )
addlib( lib-widget-extra   libextra    EXTRA       YES   YES   "" )
addlib( libsndfile         sndfile     SNDFILE     YES   YES   "sndfile >= 1.0.28" )
addlib( libsoxr            soxr        SOXR        YES   YES   "soxr >= 0.1.1" )
addlib( portaudio-v19      portaudio   PORTAUDIO   YES   YES   "" )

# Optional libraries
#
#       directory          option      symbol      req   chk   version
addlib( ffmpeg             ffmpeg      FFMPEG      NO    NO    "libavcodec >= 51.53" "libavformat >= 52.12" "libavutil >= 52.66" )
addlib( libid3tag          id3tag      LIBID3TAG   NO    YES   "id3tag >= 0.15.1b" )
addlib( libmad             mad         LIBMAD      NO    YES   "mad >= 0.15.1b" )
addlib( libnyquist         nyquist     NYQUIST     NO    YES   "" )
addlib( libvamp            vamp        VAMP        NO    YES   "vamp >= 2.5" "vamp-hostsdk >= 2.5" )
addlib( libogg             ogg         LIBOGG      NO    YES   "ogg >= 1.3.1" )
addlib( libvorbis          vorbis      LIBVORBIS   NO    YES   "vorbis >= 1.3.3" "vorbisenc >= 1.3.3" "vorbisfile >= 1.3.3" )
addlib( libflac            flac        LIBFLAC     NO    YES   "flac >= 1.3.1" "flac++ >= 1.3.1" )
addlib( lv2                lv2         LV2         NO    YES   "lilv-0 >= 0.24.6" "lv2 >= 1.16.0" "serd-0 >= 0.30.2" "sord-0 >= 0.16.4" "sratom-0 >= 0.6.4" "suil-0 >= 0.10.6" )
addlib( portmidi           midi        MIDI        NO    YES   "portmidi >= 0.1" )
addlib( portmixer          portmixer   PORTMIXER   NO    YES   "" )
addlib( portsmf            portsmf     PORTSMF     NO    YES   "portsmf >= 0.1" )
addlib( sbsms              sbsms       SBSMS       NO    YES   "" )
addlib( soundtouch         soundtouch  SOUNDTOUCH  NO    YES   "soundtouch >= 1.7.1" )
addlib( twolame            twolame     LIBTWOLAME  NO    YES   "twolame >= 0.3.13" )

=== help/CMakeLists.txt ===

set( TARGET manual )
set( TARGET_ROOT ${topdir}/manual )

message( STATUS "========== Configuring ${TARGET} ==========" )

def_vars()

if( NOT DEFINED PYTHON )
   message( WARNING "Python not found...unable to produce manual." )
   return()
endif()

set( host "alphamanual.audacityteam.org" )
set( src "https://${host}/man" )
set( dst "${_DEST}/help/manual" )
set( script_dir "${topdir}/scripts/mw2html_audacity" )
set( script "mw2html.py" )
set( out_dir "${_INTDIR}" )
set( out "${out_dir}/${host}/index.html" )

add_custom_command(
   COMMENT
      "Downloading manual from: ${src}"
   COMMAND
      "${PYTHON}" "${script_dir}/${script}" -s "${src}" "${out_dir}"
   COMMAND
      ${CMAKE_COMMAND} -E copy_directory "${out_dir}/${host}" "${dst}"
   WORKING_DIRECTORY
      "${script_dir}"
   OUTPUT
      "${out}"
)

add_custom_target( ${TARGET} DEPENDS "${out}" )

if( NOT "${CMAKE_GENERATOR}" MATCHES "Xcode|Visual Studio*" )
   install( DIRECTORY "${dst}" OPTIONAL
            DESTINATION "${_DATADIR}/audacity/help" )
   install( FILES "${_SRCDIR}/audacity.1"
            DESTINATION "${_MANDIR}/man1" )
   install( FILES "${_SRCDIR}/audacity.appdata.xml"
            DESTINATION "${_DATADIR}/appdata" )
endif()

=== locale/CMakeLists.txt ===

set( TARGET locale )
set( TARGET_ROOT ${topdir}/locale )

message( STATUS "========== Configuring ${TARGET} ==========" )

def_vars()

list( APPEND SOURCES
   af.po
   ar.po
   be.po
   bg.po
   bn.po
   bs.po
   ca.po
   ca_ES@valencia.po
   cs.po
   cy.po
   da.po
   de.po
   el.po
   es.po
   eu.po
   eu_ES.po
   fa.po
   fi.po
   fr.po
   ga.po
   gl.po
   he.po
   hi.po
   hr.po
   hu.po
   hy.po
   id.po
   it.po
   ja.po
   ka.po
   km.po
   ko.po
   lt.po
   mk.po
   my.po
   nb.po
   nl.po
   oc.po
   pl.po
   pt_BR.po
   pt_PT.po
   ro.po
   ru.po
   sk.po
   sl.po
   sr_RS.po
   sr_RS@latin.po
   sv.po
   ta.po
   tg.po
   tr.po
   uk.po
   vi.po
   zh_CN.po
   zh_TW.po
)

# Look for gettext
find_package( Gettext QUIET )
if( GETTEXT_FOUND )
   mark_as_advanced( FORCE GETTEXT_MSGFMT_EXECUTABLE )
   mark_as_advanced( FORCE GETTEXT_MSGMERGE_EXECUTABLE )
   set( msgfmt "${GETTEXT_MSGFMT_EXECUTABLE}" )
elseif( PYTHON )
   set( msgfmt "${PYTHON}" "${TARGET_ROOT}/msgfmt.py" )
elseif( CMAKE_SYSTEM_NAME MATCHES "Windows" )
   nuget_package( pkgdir "Gettext.Tools" "0.20.1.1" )
   file( TO_NATIVE_PATH "${pkgdir}/tools/bin/msgfmt.exe" msgfmt )
endif()

if( NOT DEFINED msgfmt )
   message( WARNING "The msgfmt program wasn't found...translations will not be provided." )
   return()
endif()

if( CMAKE_SYSTEM_NAME MATCHES "Darwin" )
   set( locale "${_DEST}/Resources" )
elseif( CMAKE_SYSTEM_NAME MATCHES "Windows" )
   set( locale "${_DEST}/Languages" )
else()
   set( locale "${_DEST}/locale" )
endif()

set( OUTPUTS )
foreach( source ${SOURCES} )
   get_filename_component( lang "${source}" NAME_WE )

   if( CMAKE_SYSTEM_NAME MATCHES "Darwin" )
      set( dst "${locale}/${lang}.lproj" )
   elseif( CMAKE_SYSTEM_NAME MATCHES "Windows" )
      set( dst "${locale}/${lang}" )
   else()
      set( dst "${locale}/${lang}/LC_MESSAGES" )
   endif()

   set( po "${_SRCDIR}/${source}" )
   set( mo "${dst}/audacity.mo" )

   add_custom_command(
      DEPENDS
         "${po}"
      COMMAND
         "${CMAKE_COMMAND}" -E make_directory "${dst}"
      COMMAND
         ${msgfmt} -o "${mo}" "${po}"
      OUTPUT
         "${mo}"
   )

   # Always make sure there's an empty English folder.  Otherwise, some menu
   # items will be translated to the next language listed in System
   # Preferences/Language & Text
   if( CMAKE_SYSTEM_NAME MATCHES "Darwin" )
      add_custom_command(
         COMMAND
            ${CMAKE_COMMAND} -E make_directory "${_DEST}/Resources/en.lproj"
         OUTPUT
            "${mo}"
         APPEND
      )
   endif()

   list( APPEND OUTPUTS ${mo} )
endforeach()

add_custom_target( "${TARGET}" ALL DEPENDS ${OUTPUTS} SOURCES "${SOURCES}" )

if( NOT "${CMAKE_GENERATOR}" MATCHES "Xcode|Visual Studio*" )
   install( DIRECTORY ${locale}/
            TYPE LOCALE )
endif()

=== scripts/CMakeLists.txt ===

set( TARGET minsrc )
set( TARGET_ROOT ${topdir} )

message( STATUS "========== Configuring ${TARGET} ==========" )

def_vars()

# Add regular expressions of files/directories to exclude from the tarball
#
# NOTE: Each item will be wrapped with "^" and ".*$"
list( APPEND EXCLUDES
   .git
   .gitattributes
   .github
   .gitignore
   .travis.yml
   appveyor.yml
   autotools
   configure
   configure.ac
#   lib-src/expat
#   lib-src/libid3tag
#   lib-src/libmad
#   lib-src/libogg
#   lib-src/libscorealign
#   lib-src/libvorbis
   lib-src/portaudio-v19/bindings
   lib-src/portaudio-v19/doc
   lib-src/portaudio-v19/testcvs
   lib-src/portmidi/pm_csharp
   lib-src/portmidi/pm_dylib
   lib-src/portmidi/pm_java
   lib-src/portmidi/pm_mingw
   lib-src/portmidi/pm_python
   lib-src/portmidi/pm_qt
   lib-src/portmidi/pm_test
   lib-src/portmidi/portmidi_cdt.zip
#   lib-src/soundtouch
   m4
   mac
   plug-ins/analyze.ny
   plug-ins/fadein.ny
   plug-ins/fadeout.ny
   plug-ins/undcbias.ny
   qa
   tests/ProjectCheckTests
   tests/samples
   todo.txt
   win
)

set( TLD "audacity-minsrc-${AUDACITY_DIST_VERSION}${AUDACITY_SUFFIX}" )
set( TARBALL "${PROJECT_BINARY_DIR}/${TLD}.tar.xz" )
   
add_custom_target( ${TARGET}
   COMMAND
      ${CMAKE_COMMAND} -D GIT_EXECUTABLE="${GIT_EXECUTABLE}"
                       -D TARGET_ROOT="${TARGET_ROOT}"
                       -D EXCLUDES="${EXCLUDES}"
                       -D TARBALL="${TARBALL}"
                       -D TLD="${TLD}"
                       -P "${_SRCDIR}/maketarball.cmake"
)

=== src/CMakeLists.txt ===

set( TARGET Audacity )
set( TARGET_ROOT ${topdir}/src )

message( STATUS "========== Configuring ${TARGET} ==========" )

# Allow modules to link against the Audacity executable
set( CMAKE_ENABLE_EXPORTS ON )

add_executable( ${TARGET} )
add_dependencies( ${TARGET} locale )
add_dependencies( ${TARGET} nyquist )
add_dependencies( ${TARGET} plug-ins )

def_vars()

# Add a target that will provide the git revision info
# whenever it changes.  (Must be done at build time, not
# configuration time.)
if( GIT_FOUND )
   add_custom_target(
      version
      COMMAND
         ${CMAKE_COMMAND} -D GIT=${GIT_EXECUTABLE}
                          -D _PRVDIR=${_PRVDIR}
                          -P ${CMAKE_MODULE_PATH}/Version.cmake
      WORKING_DIRECTORY
         ${topdir}
   )
   add_dependencies( ${TARGET} version )
endif()

# Handle Audio Units option
if( CMAKE_SYSTEM_NAME MATCHES "Darwin" )
   cmd_option(
      ${_OPT}use_audio_units
      "Use Audio Units plug-in support [on, off]"
      ON
   )
   set( USE_AUDIO_UNITS ${${_OPT}use_audio_units} CACHE INTERNAL "" )
endif()

# Handle Ladspa option
cmd_option(
   ${_OPT}use_ladspa
   "Use LADSPA plug-in support [on, off]"
   ON
)
set( USE_LADSPA ${${_OPT}use_ladspa} CACHE INTERNAL "" )

# Handle VST option
cmd_option(
   ${_OPT}use_vst
   "Use VST2 plug-in support [on, off]"
   ON
)
set( USE_VST ${${_OPT}use_vst} CACHE INTERNAL "" )

#
#
#
list( APPEND SOURCES
   PRIVATE
      AColor.cpp
      AColor.h
      AboutDialog.cpp
      AboutDialog.h
      AdornedRulerPanel.cpp
      AdornedRulerPanel.h
      AllThemeResources.h
      AttachedVirtualFunction.h
      Audacity.h
      AudacityApp.cpp
      AudacityApp.h
      AudacityException.cpp
      AudacityException.h
      AudacityHeaders.cpp
      AudacityHeaders.h
      AudacityLogger.cpp
      AudacityLogger.h
      AudioIO.cpp
      AudioIO.h
      AudioIOBase.cpp
      AudioIOBase.h
      AudioIOListener.h
      AutoRecovery.cpp
      AutoRecovery.h
      AutoRecoveryDialog.cpp
      AutoRecoveryDialog.h
      BatchCommandDialog.cpp
      BatchCommandDialog.h
      BatchCommands.cpp
      BatchCommands.h
      BatchProcessDialog.cpp
      BatchProcessDialog.h
      Benchmark.cpp
      Benchmark.h
      BlockFile.cpp
      BlockFile.h
      CellularPanel.cpp
      CellularPanel.h
      ClassicThemeAsCeeCode.h
      ClientData.h
      ClientDataHelpers.h
      Clipboard.cpp
      Clipboard.h
      CommonCommandFlags.cpp
      CommonCommandFlags.h
      CrashReport.cpp
      CrashReport.h
      DarkThemeAsCeeCode.h
      Dependencies.cpp
      Dependencies.h
      DeviceChange.cpp
      DeviceChange.h
      DeviceManager.cpp
      DeviceManager.h
      Diags.cpp
      Diags.h
      DirManager.cpp
      DirManager.h
      Dither.cpp
      Dither.h
      Envelope.cpp
      Envelope.h
      EnvelopeEditor.cpp
      EnvelopeEditor.h
      Experimental.h
      FFT.cpp
      FFT.h
      FFmpeg.cpp
      FFmpeg.h
      FileException.cpp
      FileException.h
      FileFormats.cpp
      FileFormats.h
      FileIO.cpp
      FileIO.h
      FileNames.cpp
      FileNames.h
      FreqWindow.cpp
      FreqWindow.h
      HelpText.cpp
      HelpText.h
      HiContrastThemeAsCeeCode.h
      HistoryWindow.cpp
      HistoryWindow.h
      HitTestResult.h
      ImageManipulation.cpp
      ImageManipulation.h
      InconsistencyException.cpp
      InconsistencyException.h
      Internat.cpp
      Internat.h
      InterpolateAudio.cpp
      InterpolateAudio.h
      KeyboardCapture.cpp
      KeyboardCapture.h
      LabelDialog.cpp
      LabelDialog.h
      LabelTrack.cpp
      LabelTrack.h
      LangChoice.cpp
      LangChoice.h
      Languages.cpp
      Languages.h
      Legacy.cpp
      Legacy.h
      LightThemeAsCeeCode.h
      Lyrics.cpp
      Lyrics.h
      LyricsWindow.cpp
      LyricsWindow.h
      MacroMagic.h
      Makefile.am
      Makefile.in
      Matrix.cpp
      Matrix.h
      MemoryX.h
      Menus.cpp
      Menus.h
      MissingAliasFileDialog.cpp
      MissingAliasFileDialog.h
      Mix.cpp
      Mix.h
      MixerBoard.cpp
      MixerBoard.h
      ModuleManager.cpp
      ModuleManager.h
      NoteTrack.cpp
      NoteTrack.h
      NumberScale.h
      PitchName.cpp
      PitchName.h
      PlatformCompatibility.cpp
      PlatformCompatibility.h
      PluginManager.cpp
      PluginManager.h
      Prefs.cpp
      Prefs.h
      Printing.cpp
      Printing.h
      Profiler.cpp
      Profiler.h
      Project.cpp
      Project.h
      ProjectAudioIO.cpp
      ProjectAudioIO.h
      ProjectAudioManager.cpp
      ProjectAudioManager.h
      ProjectFSCK.cpp
      ProjectFSCK.h
      ProjectFileIO.cpp
      ProjectFileIO.h
      ProjectFileIORegistry.cpp
      ProjectFileIORegistry.h
      ProjectFileManager.cpp
      ProjectFileManager.h
      ProjectHistory.cpp
      ProjectHistory.h
      ProjectManager.cpp
      ProjectManager.h
      ProjectSelectionManager.cpp
      ProjectSelectionManager.h
      ProjectSettings.cpp
      ProjectSettings.h
      ProjectStatus.cpp
      ProjectStatus.h
      ProjectWindow.cpp
      ProjectWindow.h
      ProjectWindowBase.cpp
      ProjectWindowBase.h
      RealFFTf.cpp
      RealFFTf.h
      RealFFTf48x.cpp
      RealFFTf48x.h
      RefreshCode.h
      Registrar.h
      Resample.cpp
      Resample.h
      RevisionIdent.h
      RingBuffer.cpp
      RingBuffer.h
      SampleFormat.cpp
      SampleFormat.h
      Screenshot.cpp
      Screenshot.h
      SelectUtilities.cpp
      SelectUtilities.h
      SelectedRegion.cpp
      SelectedRegion.h
      SelectionState.cpp
      SelectionState.h
      Sequence.cpp
      Sequence.h
      Shuttle.cpp
      Shuttle.h
      ShuttleGetDefinition.cpp
      ShuttleGetDefinition.h
      ShuttleGui.cpp
      ShuttleGui.h
      ShuttlePrefs.cpp
      ShuttlePrefs.h
      Snap.cpp
      Snap.h
      SoundActivatedRecord.cpp
      SoundActivatedRecord.h
      Spectrum.cpp
      Spectrum.h
      SpectrumAnalyst.cpp
      SpectrumAnalyst.h
      SplashDialog.cpp
      SplashDialog.h
      SseMathFuncs.cpp
      SseMathFuncs.h
      Tags.cpp
      Tags.h
      Theme.cpp
      Theme.h
      ThemeAsCeeCode.h
      TimeDialog.cpp
      TimeDialog.h
      TimeTrack.cpp
      TimeTrack.h
      TimerRecordDialog.cpp
      TimerRecordDialog.h
      Track.cpp
      Track.h
      TrackArtist.cpp
      TrackArtist.h
      TrackInfo.cpp
      TrackInfo.h
      TrackPanel.cpp
      TrackPanel.h
      TrackPanelAx.cpp
      TrackPanelAx.h
      TrackPanelCell.h
      TrackPanelDrawable.h
      TrackPanelDrawingContext.h
      TrackPanelListener.h
      TrackPanelMouseEvent.h
      TrackPanelResizeHandle.cpp
      TrackPanelResizeHandle.h
      TrackPanelResizerCell.cpp
      TrackPanelResizerCell.h
      TrackUtilities.cpp
      TrackUtilities.h
      UIHandle.cpp
      UIHandle.h
      UndoManager.cpp
      UndoManager.h
      UserException.cpp
      UserException.h
      ViewInfo.cpp
      ViewInfo.h
      VoiceKey.cpp
      VoiceKey.h
      WaveClip.cpp
      WaveClip.h
      WaveTrack.cpp
      WaveTrack.h
      WaveTrackLocation.h
      WrappedType.cpp
      WrappedType.h
      ZoomInfo.cpp
      ZoomInfo.h
      float_cast.h
      wxFileNameWrapper.h

      # Blockfile

      blockfile/LegacyAliasBlockFile.cpp
      blockfile/LegacyAliasBlockFile.h
      blockfile/LegacyBlockFile.cpp
      blockfile/LegacyBlockFile.h
      blockfile/NotYetAvailableException.cpp
      blockfile/NotYetAvailableException.h
      blockfile/ODDecodeBlockFile.cpp
      blockfile/ODDecodeBlockFile.h
      blockfile/ODPCMAliasBlockFile.cpp
      blockfile/ODPCMAliasBlockFile.h
      blockfile/PCMAliasBlockFile.cpp
      blockfile/PCMAliasBlockFile.h
      blockfile/SilentBlockFile.cpp
      blockfile/SilentBlockFile.h
      blockfile/SimpleBlockFile.cpp
      blockfile/SimpleBlockFile.h

      # Commands

      commands/AppCommandEvent.cpp
      commands/AppCommandEvent.h
      commands/AudacityCommand.cpp
      commands/AudacityCommand.h
      commands/BatchEvalCommand.cpp
      commands/BatchEvalCommand.h
      commands/Command.cpp
      commands/Command.h
      commands/CommandBuilder.cpp
      commands/CommandBuilder.h
      commands/CommandContext.cpp
      commands/CommandContext.h
      commands/CommandDirectory.cpp
      commands/CommandDirectory.h
      commands/CommandFlag.h
      commands/CommandFunctors.h
      commands/CommandHandler.cpp
      commands/CommandHandler.h
      commands/CommandManager.cpp
      commands/CommandManager.h
      commands/CommandManagerWindowClasses.h
      commands/CommandMisc.h
      commands/CommandSignature.cpp
      commands/CommandSignature.h
      commands/CommandTargets.cpp
      commands/CommandTargets.h
      commands/CommandType.cpp
      commands/CommandType.h
      commands/CompareAudioCommand.cpp
      commands/CompareAudioCommand.h
      commands/Demo.cpp
      commands/Demo.h
      commands/DragCommand.cpp
      commands/DragCommand.h
      commands/GetInfoCommand.cpp
      commands/GetInfoCommand.h
      commands/GetTrackInfoCommand.cpp
      commands/GetTrackInfoCommand.h
      commands/HelpCommand.cpp
      commands/HelpCommand.h
      commands/ImportExportCommands.cpp
      commands/ImportExportCommands.h
      commands/Keyboard.cpp
      commands/Keyboard.h
      commands/LoadCommands.cpp
      commands/LoadCommands.h
      commands/MessageCommand.cpp
      commands/MessageCommand.h
      commands/OpenSaveCommands.cpp
      commands/OpenSaveCommands.h
      commands/PreferenceCommands.cpp
      commands/PreferenceCommands.h
      commands/ResponseQueue.cpp
      commands/ResponseQueue.h
      commands/ScreenshotCommand.cpp
      commands/ScreenshotCommand.h
      commands/ScriptCommandRelay.cpp
      commands/ScriptCommandRelay.h
      commands/SelectCommand.cpp
      commands/SelectCommand.h
      commands/SetClipCommand.cpp
      commands/SetClipCommand.h
      commands/SetEnvelopeCommand.cpp
      commands/SetEnvelopeCommand.h
      commands/SetLabelCommand.cpp
      commands/SetLabelCommand.h
      commands/SetProjectCommand.cpp
      commands/SetProjectCommand.h
      commands/SetTrackInfoCommand.cpp
      commands/SetTrackInfoCommand.h
      commands/Validators.h

      # Built-in Effects

      effects/Amplify.cpp
      effects/Amplify.h
      effects/AutoDuck.cpp
      effects/AutoDuck.h
      effects/BassTreble.cpp
      effects/BassTreble.h
      effects/Biquad.cpp
      effects/Biquad.h
      effects/ChangePitch.cpp
      effects/ChangePitch.h
      effects/ChangeSpeed.cpp
      effects/ChangeSpeed.h
      effects/ChangeTempo.cpp
      effects/ChangeTempo.h
      effects/ClickRemoval.cpp
      effects/ClickRemoval.h
      effects/Compressor.cpp
      effects/Compressor.h
      effects/Contrast.cpp
      effects/Contrast.h
      effects/Distortion.cpp
      effects/Distortion.h
      effects/DtmfGen.cpp
      effects/DtmfGen.h
      effects/EBUR128.cpp
      effects/EBUR128.h
      effects/Echo.cpp
      effects/Echo.h
      effects/Effect.cpp
      effects/Effect.h
      effects/EffectManager.cpp
      effects/EffectManager.h
      effects/EffectUI.cpp
      effects/EffectUI.h
      effects/Equalization.cpp
      effects/Equalization.h
      effects/Equalization48x.cpp
      effects/Equalization48x.h
      effects/Fade.cpp
      effects/Fade.h
      effects/FindClipping.cpp
      effects/FindClipping.h
      effects/Generator.cpp
      effects/Generator.h
      effects/Invert.cpp
      effects/Invert.h
      effects/LoadEffects.cpp
      effects/LoadEffects.h
      effects/Loudness.cpp
      effects/Loudness.h
      effects/Noise.cpp
      effects/Noise.h
      effects/NoiseReduction.cpp
      effects/NoiseReduction.h
      effects/NoiseRemoval.cpp
      effects/NoiseRemoval.h
      effects/Normalize.cpp
      effects/Normalize.h
      effects/Paulstretch.cpp
      effects/Paulstretch.h
      effects/Phaser.cpp
      effects/Phaser.h
      effects/RealtimeEffectManager.cpp

=== cmake-proxies/FileDialog/CMakeLists.txt ===

add_library( ${TARGET} STATIC )

def_vars()

list( APPEND SOURCES
   PRIVATE
      ${TARGET_ROOT}/FileDialog.cpp
      $<$<BOOL:${wxIS_WIN}>:${TARGET_ROOT}/win/FileDialogPrivate.cpp>
      $<$<BOOL:${wxIS_MAC}>:${TARGET_ROOT}/mac/FileDialogPrivate.mm>
      $<$<BOOL:${wxIS_GTK}>:${TARGET_ROOT}/gtk/FileDialogPrivate.cpp>
)

list( APPEND INCLUDES
   PUBLIC
      ${TARGET_ROOT}
)

list( APPEND DEFINES
   PRIVATE
      $<$<PLATFORM_ID:Windows>:__WIN32__>
)

list( APPEND OPTIONS
   PRIVATE
      $<$<CXX_COMPILER_ID:MSVC>:/permissive->
      $<$<CXX_COMPILER_ID:AppleClang,Clang,GNU>:-Wno-deprecated-declarations>
)

list( APPEND LIBRARIES
   PRIVATE
      wxWidgets
   PUBLIC
      $<$<BOOL:${wxIS_GTK}>:PkgConfig::GTK>
)

organize_source( "${TARGET_ROOT}" "" "${SOURCES}" )
target_sources( ${TARGET} PRIVATE ${SOURCES} )
target_compile_definitions( ${TARGET} PRIVATE ${DEFINES} )
target_compile_options( ${TARGET} PRIVATE ${OPTIONS} )
target_include_directories( ${TARGET} PRIVATE ${INCLUDES} )
target_link_libraries( ${TARGET} PRIVATE ${LIBRARIES} )

=== cmake-proxies/lame/CMakeLists.txt ===

add_library( ${TARGET} STATIC )

def_vars()

list( APPEND SOURCES
   PRIVATE
      # libmp3lame
      ${TARGET_ROOT}/../libmp3lame/bitstream.c
      ${TARGET_ROOT}/../libmp3lame/encoder.c
      ${TARGET_ROOT}/../libmp3lame/fft.c
      ${TARGET_ROOT}/../libmp3lame/gain_analysis.c
      ${TARGET_ROOT}/../libmp3lame/id3tag.c
      ${TARGET_ROOT}/../libmp3lame/lame.c
      ${TARGET_ROOT}/../libmp3lame/mpglib_interface.c
      ${TARGET_ROOT}/../libmp3lame/newmdct.c
      ${TARGET_ROOT}/../libmp3lame/presets.c
      ${TARGET_ROOT}/../libmp3lame/psymodel.c
      ${TARGET_ROOT}/../libmp3lame/quantize.c
      ${TARGET_ROOT}/../libmp3lame/quantize_pvt.c
      ${TARGET_ROOT}/../libmp3lame/reservoir.c
      ${TARGET_ROOT}/../libmp3lame/set_get.c
      ${TARGET_ROOT}/../libmp3lame/tables.c
      ${TARGET_ROOT}/../libmp3lame/takehiro.c
      ${TARGET_ROOT}/../libmp3lame/util.c
      ${TARGET_ROOT}/../libmp3lame/vbrquantize.c
      ${TARGET_ROOT}/../libmp3lame/VbrTag.c
      ${TARGET_ROOT}/../libmp3lame/version.c
      ${TARGET_ROOT}/../libmp3lame/vector/xmm_quantize_sub.c

      # mpglib
      ${TARGET_ROOT}/../mpglib/common.c
      ${TARGET_ROOT}/../mpglib/dct64_i386.c
      ${TARGET_ROOT}/../mpglib/decode_i386.c
      ${TARGET_ROOT}/../mpglib/interface.c
      ${TARGET_ROOT}/../mpglib/layer1.c
      ${TARGET_ROOT}/../mpglib/layer2.c
      ${TARGET_ROOT}/../mpglib/layer3.c
      ${TARGET_ROOT}/../mpglib/tabinit.c
)

list( APPEND INCLUDES
   PRIVATE
      ${_PRVDIR}
      ${TARGET_ROOT}/../libmp3lame
      ${TARGET_ROOT}/../mpglib
   PUBLIC
      ${_PUBDIR}
)

list( APPEND DEFINES
   PRIVATE
      HAVE_CONFIG_H
)

list( APPEND OPTIONS
   PRIVATE
      ${MMX_FLAG}
      ${SSE_FLAG}
)

set( HAVE_INT8_T SIZEOF_INT8_T )
set( HAVE_INT16_T SIZEOF_INT16_T )
set( HAVE_INT32_T SIZEOF_INT32_T )
set( HAVE_INT64_T SIZEOF_INT64_T )
set( HAVE_UINT16_T SIZEOF_UINT16_T )
set( HAVE_UINT32_T SIZEOF_UINT32_T )
set( HAVE_UINT64_T SIZEOF_UINT64_T )

if( SIZEOF_SHORT EQUAL 4 )
   set( A_INT32_T int )
elseif( SIZEOF_INT EQUAL 4 )
   set( A_INT32_T int )
elseif( SIZEOF_LONG EQUAL 4 )
   set( A_INT32_T long )
endif()

if( SIZEOF_INT EQUAL 8 )
   set( A_INT64_T int )
elseif( SIZEOF_LONG EQUAL 8 )
   set( A_INT64_T long )
elseif( SIZEOF_LONG_LONG EQUAL 8 )
   set( A_INT64_T long long )
endif()

set( DECODE_ON_THE_FLY 1 )
set( HAVE_MPGLIB 1 )
set( TAKEHIRO_IEEE754_HACK 1 )
set( USE_FAST_LOG 1 )
if( ${CMakeDetermineASM_NASMCompiler} )
   set( HAVE_NASM 1 )
endif()

configure_file( config.h.in private/config.h )
configure_file( ${TARGET_ROOT}/../libmp3lame/lame.h public/lame/lame.h )

#organize_source( "${TARGET_ROOT}" "" "${SOURCES}" )
target_sources( ${TARGET} PRIVATE ${SOURCES} )
target_compile_definitions( ${TARGET} PRIVATE ${DEFINES} )
target_include_directories( ${TARGET} PRIVATE ${INCLUDES} )
target_compile_options( ${TARGET} PRIVATE ${OPTIONS} )
target_link_libraries( ${TARGET} PRIVATE ${LIBRARIES} )

=== cmake-proxies/lib-widget-extra/CMakeLists.txt ===

add_library( ${TARGET} STATIC )

def_vars()

list( APPEND SOURCES
   PRIVATE
      ${TARGET_ROOT}/NonGuiThread.cpp
)

list( APPEND INCLUDES
   PUBLIC
      ${TARGET_ROOT}
)

list( APPEND LIBRARIES
   PRIVATE
      wxWidgets
)

organize_source( "${TARGET_ROOT}" "" "${SOURCES}" )
target_sources( ${TARGET} PRIVATE ${SOURCES} )
target_include_directories( ${TARGET} PRIVATE ${INCLUDES} )
target_link_libraries( ${TARGET} PRIVATE ${LIBRARIES} )

=== cmake-proxies/libflac/CMakeLists.txt ===

# FIXME:  Once switch to cmake is made, remove Windows pragmas
#         from AudacityApp.cpp and change target name to "flac/flac++"
add_library( ${TARGET} STATIC )
add_library( ${TARGET}++ STATIC )

def_vars()

list( APPEND SOURCES
   PRIVATE

      # libflac
      ${TARGET_ROOT}/src/libFLAC/bitmath.c
      ${TARGET_ROOT}/src/libFLAC/bitreader.c
      ${TARGET_ROOT}/src/libFLAC/bitwriter.c
      ${TARGET_ROOT}/src/libFLAC/cpu.c
      ${TARGET_ROOT}/src/libFLAC/crc.c
      ${TARGET_ROOT}/src/libFLAC/fixed.c
      ${TARGET_ROOT}/src/libFLAC/fixed_intrin_sse2.c
      ${TARGET_ROOT}/src/libFLAC/fixed_intrin_ssse3.c
      ${TARGET_ROOT}/src/libFLAC/float.c
      ${TARGET_ROOT}/src/libFLAC/format.c
      ${TARGET_ROOT}/src/libFLAC/lpc.c
      ${TARGET_ROOT}/src/libFLAC/lpc_intrin_sse.c
      ${TARGET_ROOT}/src/libFLAC/lpc_intrin_sse2.c
      ${TARGET_ROOT}/src/libFLAC/lpc_intrin_sse41.c
      ${TARGET_ROOT}/src/libFLAC/lpc_intrin_avx2.c
      ${TARGET_ROOT}/src/libFLAC/md5.c
      ${TARGET_ROOT}/src/libFLAC/memory.c
      ${TARGET_ROOT}/src/libFLAC/metadata_iterators.c
      ${TARGET_ROOT}/src/libFLAC/metadata_object.c
      ${TARGET_ROOT}/src/libFLAC/stream_decoder.c
      ${TARGET_ROOT}/src/libFLAC/stream_encoder.c
      ${TARGET_ROOT}/src/libFLAC/stream_encoder_intrin_sse2.c
      ${TARGET_ROOT}/src/libFLAC/stream_encoder_intrin_ssse3.c
      ${TARGET_ROOT}/src/libFLAC/stream_encoder_intrin_avx2.c
      ${TARGET_ROOT}/src/libFLAC/stream_encoder_framing.c
      ${TARGET_ROOT}/src/libFLAC/window.c
      ${TARGET_ROOT}/src/libFLAC/ogg_decoder_aspect.c
      ${TARGET_ROOT}/src/libFLAC/ogg_encoder_aspect.c
      ${TARGET_ROOT}/src/libFLAC/ogg_helper.c
      ${TARGET_ROOT}/src/libFLAC/ogg_mapping.c
      $<$<BOOL:${WIN32}>:${TARGET_ROOT}/src/share/win_utf8_io/win_utf8_io.c>
)

list( APPEND SOURCES++ 
      # libflac++
      ${TARGET_ROOT}/src/libFLAC++/metadata.cpp
      ${TARGET_ROOT}/src/libFLAC++/stream_decoder.cpp
      ${TARGET_ROOT}/src/libFLAC++/stream_encoder.cpp
)

list( APPEND INCLUDES
   PRIVATE
      ${_PRVDIR}
      ${TARGET_ROOT}/src/libFLAC/include
   PUBLIC
      ${TARGET_ROOT}/include
)

list( APPEND DEFINES
   PRIVATE
      HAVE_CONFIG_H
   PUBLIC
      FLAC__NO_DLL
)

list( APPEND LIBRARIES
   PUBLIC
      libogg
      libflac++
)

list( APPEND LIBRARIES++
   PRIVATE
      libflac
)

set( CPU_IS_BIG_ENDIAN ${WORDS_BIGENDIAN} )
set( CPU_IS_LITTLE_ENDIAN !${WORDS_BIGENDIAN} )

set( FLAC__HAS_OGG 1 )

set( VERSION "1.3.1" )

configure_file( config.h.in private/config.h )

organize_source( "${TARGET_ROOT}" "" "${SOURCES}" )
target_sources( ${TARGET} PRIVATE ${SOURCES} )
target_compile_definitions( ${TARGET} PRIVATE ${DEFINES} )
target_include_directories( ${TARGET} PRIVATE ${INCLUDES} )
target_link_libraries( ${TARGET} PRIVATE ${LIBRARIES} )

organize_source( "${TARGET_ROOT}" "" "${SOURCES++}" )
target_sources( ${TARGET}++ PRIVATE ${SOURCES++} )
target_compile_definitions( ${TARGET}++ PRIVATE ${DEFINES} )
target_include_directories( ${TARGET}++ PRIVATE ${INCLUDES} )
target_link_libraries( ${TARGET}++ PRIVATE ${LIBRARIES++} )

=== cmake-proxies/libogg/CMakeLists.txt ===

add_library( ${TARGET} STATIC )

def_vars()

list( APPEND SOURCES
   PRIVATE
      ${TARGET_ROOT}/src/bitwise.c
      ${TARGET_ROOT}/src/framing.c
)

list( APPEND INCLUDES
   PUBLIC
      ${_PUBDIR}
      ${TARGET_ROOT}/include
)

if( SIZEOF_INT16 EQUAL 2 )
    set( SIZE16 "int16_t" )
elseif( SIZEOF_SHORT EQUAL 2 )
    set( SIZE16 "short" )
elseif( SIZEOF_INT EQUAL 2 )
    set( SIZE16 "int" )
else()
    message( FATAL_ERROR "No 16 bit type found on this platform!" )
endif()

if( SIZEOF_UINT16 EQUAL 2 )
    set( USIZE16 "uint16_t" )
elseif( SIZEOF_SHORT EQUAL 2 )
    set( USIZE16 "unsigned short" )
elseif( SIZEOF_INT EQUAL 2 )
    set( USIZE16 "unsigned int" )
elseif( SIZEOF_U_INT EQUAL 2 )
    set( USIZE16 "u_int16_t" )
else()
    message( FATAL_ERROR "No unsigned 16 bit type found on this platform!" )
endif()

if( SIZEOF_INT32 EQUAL 4 )
    set( SIZE32 "int32_t" )
elseif( SIZEOF_SHORT EQUAL 4 )
    set( SIZE32 "short" )
elseif( SIZEOF_INT EQUAL 4 )
    set( SIZE32 "int" )
elseif( SIZEOF_LONG EQUAL 4 )
    set( SIZE16 "long" )
else()
    message( FATAL_ERROR "No 32 bit type found on this platform!" )
endif()

if( SIZEOF_UINT32 EQUAL 4 )
    set( USIZE32 "uint32_t" )
elseif( SIZEOF_SHORT EQUAL 4 )
    set( USIZE32 "unsigned short" )
elseif( SIZEOF_INT EQUAL 4 )
    set( USIZE32 "unsigned int" )
elseif( SIZEOF_LONG EQUAL 4 )
    set( USIZE32 "unsigned long" )
elseif( SIZEOF_U_INT EQUAL 4 )
    set( USIZE32 "u_int32_t" )
else()
    message( FATAL_ERROR "No unsigned 32 bit type found on this platform!" )
endif()

if( SIZEOF_INT64 EQUAL 8 )
    set( SIZE64 "int64_t" )
elseif( SIZEOF_INT EQUAL 8 )
    set( SIZE64 "int" )
elseif( SIZEOF_LONG EQUAL 8 )
    set( SIZE64 "long" )
elseif( SIZEOF_LONG_LONG EQUAL 8 )
    set( SIZE64 "long long" )
else()
    message( FATAL_ERROR "No 64 bit type found on this platform!" )
endif()

set( INCLUDE_INTTYPES_H ${HAVE_INTTYPES_H} )
set( INCLUDE_STDINT_H ${HAVE_STDINT_H} )
set( INCLUDE_SYS_TYPES_H ${HAVE_SYS_TYPES_H} )

configure_file( config_types.h.in public/ogg/config_types.h )

organize_source( "${TARGET_ROOT}" "" "${SOURCES}" )
target_sources( ${TARGET} PRIVATE ${SOURCES} )
target_compile_definitions( ${TARGET} PRIVATE ${DEFINES} )
target_include_directories( ${TARGET} PRIVATE ${INCLUDES} )

=== cmake-proxies/libsndfile/CMakeLists.txt ===

add_library( ${TARGET} STATIC )

def_vars()

list( APPEND SOURCES
   PRIVATE
      ${TARGET_ROOT}/src/ALAC/ALACBitUtilities.c
      ${TARGET_ROOT}/src/ALAC/ag_dec.c
      ${TARGET_ROOT}/src/ALAC/ag_enc.c
      ${TARGET_ROOT}/src/ALAC/alac_decoder.c
      ${TARGET_ROOT}/src/ALAC/alac_encoder.c
      ${TARGET_ROOT}/src/ALAC/dp_dec.c
      ${TARGET_ROOT}/src/ALAC/dp_enc.c
      ${TARGET_ROOT}/src/ALAC/matrix_dec.c
      ${TARGET_ROOT}/src/ALAC/matrix_enc.c
      ${TARGET_ROOT}/src/G72x/g721.c
      ${TARGET_ROOT}/src/G72x/g723_16.c
      ${TARGET_ROOT}/src/G72x/g723_24.c
      ${TARGET_ROOT}/src/G72x/g723_40.c
      ${TARGET_ROOT}/src/G72x/g72x.c
      ${TARGET_ROOT}/src/GSM610/add.c
      ${TARGET_ROOT}/src/GSM610/code.c
      ${TARGET_ROOT}/src/GSM610/decode.c
      ${TARGET_ROOT}/src/GSM610/gsm_create.c
      ${TARGET_ROOT}/src/GSM610/gsm_decode.c
      ${TARGET_ROOT}/src/GSM610/gsm_destroy.c
      ${TARGET_ROOT}/src/GSM610/gsm_encode.c
      ${TARGET_ROOT}/src/GSM610/gsm_option.c
      ${TARGET_ROOT}/src/GSM610/long_term.c
      ${TARGET_ROOT}/src/GSM610/lpc.c
      ${TARGET_ROOT}/src/GSM610/preprocess.c
      ${TARGET_ROOT}/src/GSM610/rpe.c
      ${TARGET_ROOT}/src/GSM610/short_term.c
      ${TARGET_ROOT}/src/GSM610/table.c
      ${TARGET_ROOT}/src/aiff.c
      ${TARGET_ROOT}/src/alac.c
      ${TARGET_ROOT}/src/alaw.c
      ${TARGET_ROOT}/src/au.c
      ${TARGET_ROOT}/src/audio_detect.c
      ${TARGET_ROOT}/src/avr.c
      ${TARGET_ROOT}/src/broadcast.c
      ${TARGET_ROOT}/src/caf.c
      ${TARGET_ROOT}/src/cart.c
      ${TARGET_ROOT}/src/chanmap.c
      ${TARGET_ROOT}/src/chunk.c
      ${TARGET_ROOT}/src/command.c
      ${TARGET_ROOT}/src/common.c
      ${TARGET_ROOT}/src/dither.c
      ${TARGET_ROOT}/src/double64.c
      ${TARGET_ROOT}/src/dwd.c
      ${TARGET_ROOT}/src/dwvw.c
      ${TARGET_ROOT}/src/file_io.c
      ${TARGET_ROOT}/src/flac.c
      ${TARGET_ROOT}/src/float32.c
      ${TARGET_ROOT}/src/g72x.c
      ${TARGET_ROOT}/src/gsm610.c
      ${TARGET_ROOT}/src/htk.c
      ${TARGET_ROOT}/src/id3.c
      ${TARGET_ROOT}/src/ima_adpcm.c
      ${TARGET_ROOT}/src/ima_oki_adpcm.c
      ${TARGET_ROOT}/src/interleave.c
      ${TARGET_ROOT}/src/ircam.c
      ${TARGET_ROOT}/src/macos.c
      ${TARGET_ROOT}/src/mat4.c
      ${TARGET_ROOT}/src/mat5.c
      ${TARGET_ROOT}/src/mpc2k.c
      ${TARGET_ROOT}/src/ms_adpcm.c
      ${TARGET_ROOT}/src/nist.c
      ${TARGET_ROOT}/src/nms_adpcm.c
      ${TARGET_ROOT}/src/ogg.c
      ${TARGET_ROOT}/src/ogg_opus.c
      ${TARGET_ROOT}/src/ogg_pcm.c
      ${TARGET_ROOT}/src/ogg_speex.c
      ${TARGET_ROOT}/src/ogg_vcomment.c
      ${TARGET_ROOT}/src/ogg_vorbis.c
      ${TARGET_ROOT}/src/paf.c
      ${TARGET_ROOT}/src/pcm.c
      ${TARGET_ROOT}/src/pvf.c
      ${TARGET_ROOT}/src/raw.c
      ${TARGET_ROOT}/src/rf64.c
      ${TARGET_ROOT}/src/rx2.c
      ${TARGET_ROOT}/src/sd2.c
      ${TARGET_ROOT}/src/sds.c
      ${TARGET_ROOT}/src/sndfile.c
      ${TARGET_ROOT}/src/strings.c
      ${TARGET_ROOT}/src/svx.c
      ${TARGET_ROOT}/src/txw.c
      ${TARGET_ROOT}/src/ulaw.c
      ${TARGET_ROOT}/src/voc.c
      ${TARGET_ROOT}/src/vox_adpcm.c
      ${TARGET_ROOT}/src/w64.c
      ${TARGET_ROOT}/src/wav.c
      ${TARGET_ROOT}/src/wavlike.c
      ${TARGET_ROOT}/src/wve.c
      ${TARGET_ROOT}/src/xi.c
)

list( APPEND INCLUDES
   PRIVATE
      ${_PRVDIR}
      ${TARGET_ROOT}/src
   PUBLIC
      ${_PUBDIR}
)

list( APPEND DEFINES
   PRIVATE
      inline=__inline
      LIBSNDFILE_PRIVATE_CONFIG
)

list( APPEND OPTIONS
   PRIVATE
      $<$<C_COMPILER_ID:MSVC>:/wd4996>
)

if( CMAKE_C_COMPILER_ID MATCHES "MSVC" )
    cmake_push_check_state( RESET )
    set( CMAKE_EXTRA_INCLUDE_FILES "BaseTsd.h" )
    check_type_size( "SSIZE_T" SIZEOF_SSIZE LANGUAGE C )
    list( APPEND DEFINES ssize_t=SSIZE_T )
    cmake_pop_check_state()
else()
    check_type_size( "ssize_t" SIZEOF_SSIZE LANGUAGE C )
endif()

set( TYPEOF_SF_COUNT_T "int64_t" )
check_type_size( "${TYPEOF_SF_COUNT_T}" SIZEOF_SF_COUNT_T LANGUAGE C )
set( SF_COUNT_MAX "0x7FFFFFFFFFFFFFFFLL" )

configure_file( ${TARGET_ROOT}/src/sndfile.h.in ${_PUBDIR}/sndfile.h )

check_symbol_exists( S_IRGRP "sys/stat.h" HAVE_DECL_S_IRGRP )

set( COMPILER_IS_GCC OFF )
if( CMAKE_C_COMPILER_ID MATCHES "GNU|.*Clang" )
   set( COMPILER_IS_GCC ON )
endif()

set( OS_IS_MACOSX OFF)
if( CMAKE_SYSTEM_NAME MATCHES "Darwin" )
   set( OS_IS_MACOSX ON )
endif()

set( OS_IS_WIN32 OFF )
set( USE_WINDOWS_API OFF )
if( CMAKE_SYSTEM_NAME MATCHES "Windows" )
   set( OS_IS_MACOSX ON )
   set( USE_WINDOWS_API ON )
endif()

set( CPU_IS_BIG_ENDIAN ${WORDS_BIGENDIAN} )
set( CPU_IS_LITTLE_ENDIAN !${WORDS_BIGENDIAN} )
set( HAVE_EXTERNAL_LIBS 0 )

set( VERSION "1.0.24" )
set( PACKAGE "libsndfile" )
set( PACKAGE_NAME ${PACKAGE} )
set( PACKAGE_VERSION ${VERSION} )

# Does compiler support "flexible array members"
try_compile( HAVE_FLEXIBLE_ARRAY
   ${CMAKE_CURRENT_BINARY_DIR}
   ${_SRCDIR}/famcheck.c
   LINK_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES}
   OUTPUT_VARIABLE c_out
)

# Determine how the CPU clips when doing float to int conversions
try_run( r_rc c_rc
   ${CMAKE_CURRENT_BINARY_DIR}
   ${_SRCDIR}/clipcheck.c
   LINK_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES}
   RUN_OUTPUT_VARIABLE r_out
   COMPILE_OUTPUT_VARIABLE c_out
)

if( NOT c_rc )
   message( STATUS "${c_out}" )
   message( FATAL_ERROR "${_SRCDIR}/clipcheck.c compile failed:" )
endif()

list( GET r_out 0 CPU_CLIPS_POSITIVE )
list( GET r_out 1 CPU_CLIPS_NEGATIVE )

configure_file( ${TARGET_ROOT}/src/config.h.cmake ${_PRVDIR}/config.h )

organize_source( "${TARGET_ROOT}" "" "${SOURCES}" )
target_sources( ${TARGET} PRIVATE ${SOURCES} )
target_compile_definitions( ${TARGET} PRIVATE ${DEFINES} )
target_compile_options( ${TARGET} PRIVATE ${OPTIONS} )
target_include_directories( ${TARGET} PRIVATE ${INCLUDES} )

=== debian/changelog ===
audacity (2.4.1-0.1~mx19+1) mx; urgency=medium

  * New upstream release.
  * Drop libsbsms-dev and liblv2-dev BDs; build internal versions instead.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 22 May 2020 07:48:18 -0700

audacity (2.3.3-0.1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 24 Nov 2019 11:21:51 -0800

audacity (2.3.3-1build1~ubuntu19.10) eoan; urgency=low

  * new upstream release.

 -- pandajim (key for lives deb) <ubuntuhandbook1@gmail.com>  Fri, 29 Jan 2016 19:31:05 +0100

=== debian/control ===
Source: audacity
Section: sound
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Free Ekanayaka <freee@debian.org>,
           Benjamin Drung <bdrung@debian.org>,
           David Henningsson <diwic@ubuntu.com>
Standards-Version: 3.9.6
Build-Depends: autoconf,
               automake,
               debhelper (>= 9),
               dh-autoreconf,
               gettext,
               libasound2-dev [linux-any],
               libavcodec-dev (>= 6:0.8),
               libavformat-dev (>= 6:0.8),
               libavutil-dev (>= 6:0.8),
               libexpat1-dev,
               libflac++-dev,
               libgtk2.0-dev,
               libid3tag0-dev,
               libjack-dev,
               liblilv-dev,
               libmad0-dev (>= 0.14.2b),
               libmp3lame-dev,
               libogg-dev (>= 1.0.0),
               libportsmf-dev,
#               libsbsms-dev (>= 2.0.0),
               libsndfile1-dev (>= 1.0.0),
               libsoundtouch-dev (>= 1.3.1-2),
               libsoxr-dev (>= 0.0.5),
               libsuil-dev,
               libtwolame-dev (>= 0.3.9),
               libvorbis-dev (>= 1.0.0-3),
               libwxgtk3.0-dev,
#              lv2-dev,
               libudev-dev,
               portaudio19-dev (>= 19+svn20101113-3~),
               vamp-plugin-sdk (>= 2.0)
Homepage: http://audacityteam.org/
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/audacity.git
Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/audacity.git

Package: audacity
Architecture: any
Depends: audacity-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: ladspa-plugin
Description: fast, cross-platform audio editor
 Audacity is a multi-track audio editor for Linux/Unix, MacOS and
 Windows.  It is designed for easy recording, playing and editing of
 digital audio.  Audacity features digital effects and spectrum
 analysis tools.  Editing is very fast and provides unlimited
 undo/redo.
 .
 Supported file formats include Ogg Vorbis, MP2, MP3, WAV, AIFF, and AU.

Package: audacity-data
Architecture: all
Depends: ${misc:Depends}
Recommends: audacity
Description: fast, cross-platform audio editor (data)
 Audacity is a multi-track audio editor for Linux/Unix, MacOS and
 Windows.  It is designed for easy recording, playing and editing of
 digital audio.  Audacity features digital effects and spectrum
 analysis tools.  Editing is very fast and provides unlimited
 undo/redo.
 .
 This package contains the architecture-independent data files.
